module VersionOne

  class AttributeDefinition

    def initialize(xml)
      @xml = xml
      @original_type = @xml.attributes['attributetype']
    end

    def name
      @name ||= @xml.attributes['name']
    end

    def type
      @type ||= @original_type.downcase.to_sym
    end

    def multivalue?
      bool('ismultivalue')
    end

    def readonly?
      bool('isreadonly')
    end

    def required?
      bool('isrequired')
    end

    def relation?
      self.type == :relation
    end

    def attribute?
      !relation?
    end

    def inspect
      '#<AttributeDefinition:%s:%s>' % [self.name, @original_type]
    end

    private

    def bool(name)
      @xml.attributes[name] == 'True'
    end

  end

end
