module VersionOne
  TIME_FORMAT_NO_ZONE = '%Y-%m-%dT%H:%M:%S.%L'
  TIME_FORMAT_WITH_ZONE = TIME_FORMAT_NO_ZONE + '%z'

  def self.time_to_s(t, tz=true)
    t.strftime(tz ? TIME_FORMAT_WITH_ZONE : TIME_FORMAT_NO_ZONE)
  end

  def self.s_to_time(s, options={})
    options[:utc] ||= true
    options[:tz] ||= true

    if s =~ /^[^T]+(T[^-+]+)?([-+]\d+)?$/
      s += 'T00:00:00' unless $1
      s += options[:utc] ? '+0000' : '-0700' if !$2 && options[:tz]
    end

    Time.parse(s)
  end


end